Index: trunk/SophyaLib/NTools/Makefile
===================================================================
--- trunk/SophyaLib/NTools/Makefile	(revision 509)
+++ trunk/SophyaLib/NTools/Makefile	(revision 510)
@@ -3,228 +3,275 @@
 all: $(LIB)libNTools.a
 clean:
-	rm -f $(OBJ)cimage.o $(OBJ)cspline.o $(OBJ)cvector.o $(OBJ)datacards.o $(OBJ)datatypes.o $(OBJ)dates.o $(OBJ)difeq.o $(OBJ)dvlist.o $(OBJ)dynccd.o $(OBJ)fct1dfit.o $(OBJ)fct2dfit.o $(OBJ)generaldata.o $(OBJ)generalfit.o $(OBJ)hisprof.o $(OBJ)histos.o $(OBJ)histos2.o $(OBJ)imageop.o $(OBJ)integ.o $(OBJ)linfit.o $(OBJ)matrix.o $(OBJ)median.o $(OBJ)ntuple.o $(OBJ)outilsinit.o $(OBJ)perandom.o $(OBJ)poly.o $(OBJ)pversion.o $(OBJ)rk4cdifeq.o $(OBJ)rzimage.o $(OBJ)simplesort.o $(OBJ)tabmath.o $(OBJ)utils.o $(OBJ)datime.o $(OBJ)matxop.o $(OBJ)nbmath.o $(OBJ)nbrandom.o $(OBJ)nbtri.o $(OBJ)strutil.o
+	rm -f $(OBJ)cimage.o $(OBJ)cspline.o $(OBJ)cvector.o $(OBJ)datacards.o $(OBJ)datatypes.o $(OBJ)dates.o $(OBJ)difeq.o $(OBJ)dvlist.o $(OBJ)dynccd.o $(OBJ)fct1dfit.o $(OBJ)fct2dfit.o $(OBJ)fftserver.o $(OBJ)generaldata.o $(OBJ)generalfit.o $(OBJ)hisprof.o $(OBJ)histos.o $(OBJ)histos2.o $(OBJ)imageop.o $(OBJ)integ.o $(OBJ)linfit.o $(OBJ)matrix.o $(OBJ)median.o $(OBJ)ntupintf.o $(OBJ)ntuple.o $(OBJ)outilsinit.o $(OBJ)perandom.o $(OBJ)poly.o $(OBJ)pversion.o $(OBJ)rk4cdifeq.o $(OBJ)rzimage.o $(OBJ)simplesort.o $(OBJ)tabmath.o $(OBJ)tmatrix.o $(OBJ)tvector.o $(OBJ)utils.o $(OBJ)datime.o $(OBJ)fftpackc.o $(OBJ)matxop.o $(OBJ)nbmath.o $(OBJ)nbrandom.o $(OBJ)nbtri.o $(OBJ)strutil.o
 	rm $(LIB)libNTools.a
-$(LIB)libNTools.a : $(OBJ)cimage.o $(OBJ)cspline.o $(OBJ)cvector.o $(OBJ)datacards.o $(OBJ)datatypes.o $(OBJ)dates.o $(OBJ)datime.o $(OBJ)difeq.o $(OBJ)dvlist.o $(OBJ)dynccd.o $(OBJ)fct1dfit.o $(OBJ)fct2dfit.o $(OBJ)generaldata.o $(OBJ)generalfit.o $(OBJ)hisprof.o $(OBJ)histos.o $(OBJ)histos2.o $(OBJ)imageop.o $(OBJ)integ.o $(OBJ)linfit.o $(OBJ)matrix.o $(OBJ)matxop.o $(OBJ)median.o $(OBJ)nbmath.o $(OBJ)nbrandom.o $(OBJ)nbtri.o $(OBJ)ntuple.o $(OBJ)outilsinit.o $(OBJ)perandom.o $(OBJ)poly.o $(OBJ)pversion.o $(OBJ)rk4cdifeq.o $(OBJ)rzimage.o $(OBJ)simplesort.o $(OBJ)strutil.o $(OBJ)tabmath.o $(OBJ)utils.o
-	$(AR) $(ARFLAGS) $@ $?
+$(LIB)libNTools.a : $(OBJ)cimage.o $(OBJ)cspline.o  $(OBJ)cvector.o $(OBJ)datacards.o $(OBJ)datatypes.o $(OBJ)dates.o $(OBJ)datime.o $(OBJ)difeq.o $(OBJ)dvlist.o $(OBJ)dynccd.o $(OBJ)fct1dfit.o $(OBJ)fct2dfit.o $(OBJ)fftpackc.o $(OBJ)fftserver.o $(OBJ)generaldata.o $(OBJ)generalfit.o $(OBJ)hisprof.o $(OBJ)histos.o $(OBJ)histos2.o $(OBJ)imageop.o $(OBJ)integ.o $(OBJ)linfit.o $(OBJ)matrix.o $(OBJ)matxop.o $(OBJ)median.o $(OBJ)nbmath.o $(OBJ)nbrandom.o $(OBJ)nbtri.o $(OBJ)ntupintf.o $(OBJ)ntuple.o $(OBJ)outilsinit.o $(OBJ)perandom.o $(OBJ)poly.o $(OBJ)pversion.o $(OBJ)rk4cdifeq.o $(OBJ)rzimage.o $(OBJ)simplesort.o $(OBJ)strutil.o $(OBJ)tabmath.o $(OBJ)tmatrix.o $(OBJ)tvector.o $(OBJ)utils.o
+	$(ARCXX) $(ARCXXFLAGS) $@ $?
 ifeq ($(CXX),cxx)
-	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -L$(LIB) -lNTools -o $(OBJ)xx.x -Hf
+	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -L$(LIB) -lNTools -lSamba -o $(OBJ)xx.x -Hf
 endif 
  
-$(OBJ)cimage.o: cimage.cc $(INC)defs.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h cimage.h rzimage.h rzvect.h \
- $(INC)machine.h datatypes.h \
- $(INC)ppersist.h \
- $(INC)pclassids.h dvlist.h fct1dfit.h \
- generalfit.h matrix.h peida.h utils.h fmath.h cvector.h generaldata.h \
+$(OBJ)cimage.o: cimage.cc $(INC)machdefs.h \
+ $(INC)pclassids.h \
+ $(INC)perrors.h \
+ $(INC)pexceptions.h cimage.h rzimage.h \
+ rzvect.h datatypes.h $(INC)ppersist.h \
+ $(INC)md5.h dvlist.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h fct1dfit.h generalfit.h \
+ matrix.h peida.h utils.h fmath.h cvector.h generaldata.h ntupintf.h \
  poly.h histos.h nbconst.h
-$(OBJ)cspline.o: cspline.cc $(INC)defs.h nbtri.h \
- cspline.h cvector.h matrix.h peida.h utils.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h fmath.h \
- $(INC)ppersist.h \
+$(OBJ)cspline.o: cspline.cc $(INC)machdefs.h \
+ $(INC)pclassids.h nbtri.h cspline.h \
+ cvector.h matrix.h peida.h utils.h \
+ $(INC)perrors.h \
+ $(INC)pexceptions.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)md5.h
+$(OBJ)cvector.o: cvector.cc $(INC)machdefs.h \
+ $(INC)pclassids.h cvector.h matrix.h \
+ peida.h utils.h $(INC)perrors.h \
+ $(INC)pexceptions.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)md5.h generalfit.h generaldata.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h ntupintf.h poly.h \
+ tvector.h tmatrix.h $(INC)ndatablock.h
+$(OBJ)datacards.o: datacards.cc $(INC)machdefs.h \
+ $(INC)pclassids.h datacards.h peida.h \
+ utils.h $(INC)perrors.h \
+ $(INC)pexceptions.h fmath.h
+$(OBJ)datatypes.o: datatypes.cc datatypes.h \
+ $(INC)machdefs.h \
  $(INC)pclassids.h
-$(OBJ)cvector.o: cvector.cc $(INC)defs.h cvector.h \
- matrix.h peida.h utils.h $(INC)machine.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h fmath.h \
- $(INC)ppersist.h \
- $(INC)pclassids.h generalfit.h generaldata.h \
- poly.h
-$(OBJ)datacards.o: datacards.cc $(INC)defs.h \
- datacards.h peida.h utils.h $(INC)machine.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h fmath.h
-$(OBJ)datatypes.o: datatypes.cc $(INC)defs.h \
- datatypes.h $(INC)machine.h
-$(OBJ)dates.o: dates.cc $(INC)defs.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h dates.h
-$(OBJ)difeq.o: difeq.cc $(INC)defs.h difeq.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h cvector.h matrix.h peida.h \
- utils.h $(INC)machine.h \
- $(INC)perrors.h fmath.h \
- $(INC)ppersist.h \
- $(INC)pclassids.h \
- $(INC)ctimer.h \
- $(INC)peida.h
-$(OBJ)dvlist.o: dvlist.cc $(INC)defs.h dvlist.h \
- $(INC)ppersist.h \
- $(INC)machine.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h \
- $(INC)pclassids.h strutil.h
-$(OBJ)dynccd.o: dynccd.cc $(INC)defs.h fmath.h \
- perandom.h $(INC)machine.h histos.h peida.h \
+$(OBJ)dates.o: dates.cc $(INC)machdefs.h \
+ $(INC)pclassids.h \
+ $(INC)perrors.h \
+ $(INC)pexceptions.h dates.h
+$(OBJ)difeq.o: difeq.cc difeq.h $(INC)machdefs.h \
+ $(INC)pclassids.h \
+ $(INC)pexceptions.h cvector.h matrix.h \
+ peida.h utils.h $(INC)perrors.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)md5.h \
+ $(INC)ctimer.h
+$(OBJ)dvlist.o: dvlist.cc $(INC)machdefs.h \
+ $(INC)pclassids.h dvlist.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)md5.h strutil.h
+$(OBJ)dynccd.o: dynccd.cc $(INC)machdefs.h \
+ $(INC)pclassids.h fmath.h perandom.h \
+ histos.h $(INC)objfio.h \
+ $(INC)anydataobj.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)md5.h peida.h utils.h \
+ $(INC)perrors.h cvector.h matrix.h \
+ nbrandom.h cimage.h rzimage.h rzvect.h datatypes.h dvlist.h dynccd.h
+$(OBJ)fct1dfit.o: fct1dfit.cc $(INC)machdefs.h \
+ $(INC)pclassids.h fct1dfit.h generalfit.h \
+ $(INC)pexceptions.h matrix.h peida.h \
+ utils.h $(INC)perrors.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)md5.h cvector.h generaldata.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h ntupintf.h poly.h \
+ nbconst.h tabmath.h
+$(OBJ)fct2dfit.o: fct2dfit.cc $(INC)machdefs.h \
+ $(INC)pclassids.h fct2dfit.h generalfit.h \
+ $(INC)pexceptions.h matrix.h peida.h \
+ utils.h $(INC)perrors.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)md5.h cvector.h generaldata.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h ntupintf.h poly.h \
+ nbconst.h tabmath.h simps2d.h
+$(OBJ)fftserver.o: fftserver.cc fftserver.h cvector.h matrix.h peida.h \
+ $(INC)machdefs.h \
+ $(INC)pclassids.h utils.h \
+ $(INC)perrors.h \
+ $(INC)pexceptions.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)md5.h
+$(OBJ)generaldata.o: generaldata.cc \
+ $(INC)machdefs.h \
+ $(INC)pclassids.h strutil.h nbtri.h \
+ generalfit.h $(INC)pexceptions.h matrix.h \
+ peida.h utils.h $(INC)perrors.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)md5.h cvector.h generaldata.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h ntupintf.h poly.h
+$(OBJ)generalfit.o: generalfit.cc $(INC)machdefs.h \
+ $(INC)pclassids.h \
+ $(INC)pexceptions.h generalfit.h matrix.h \
+ peida.h utils.h $(INC)perrors.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)md5.h cvector.h generaldata.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h ntupintf.h poly.h
+$(OBJ)hisprof.o: hisprof.cc $(INC)machdefs.h \
+ $(INC)pclassids.h hisprof.h peida.h utils.h \
+ $(INC)perrors.h \
+ $(INC)pexceptions.h fmath.h cvector.h \
+ matrix.h $(INC)ppersist.h \
+ $(INC)md5.h histos.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h
+$(OBJ)histos.o: histos.cc $(INC)machdefs.h \
+ $(INC)pclassids.h histos.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)md5.h peida.h utils.h \
+ $(INC)perrors.h fmath.h cvector.h matrix.h \
+ poly.h strutil.h generalfit.h generaldata.h ntupintf.h
+$(OBJ)histos2.o: histos2.cc $(INC)machdefs.h \
+ $(INC)pclassids.h histos2.h peida.h utils.h \
+ $(INC)perrors.h \
+ $(INC)pexceptions.h fmath.h histos.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h \
+ $(INC)ppersist.h \
+ $(INC)md5.h cvector.h matrix.h generalfit.h \
+ generaldata.h ntupintf.h poly.h
+$(OBJ)imageop.o: imageop.cc $(INC)machdefs.h \
+ $(INC)pclassids.h simplesort.h peida.h \
  utils.h $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h cvector.h matrix.h \
- $(INC)ppersist.h \
- $(INC)pclassids.h nbrandom.h cimage.h \
- rzimage.h rzvect.h datatypes.h dvlist.h dynccd.h
-$(OBJ)fct1dfit.o: fct1dfit.cc $(INC)defs.h fct1dfit.h \
- generalfit.h $(INC)exceptions.h \
- $(INC)peidainit.h matrix.h peida.h utils.h \
- $(INC)machine.h \
- $(INC)perrors.h fmath.h \
- $(INC)ppersist.h \
- $(INC)pclassids.h cvector.h generaldata.h \
- poly.h nbconst.h tabmath.h
-$(OBJ)fct2dfit.o: fct2dfit.cc $(INC)defs.h fct2dfit.h \
- generalfit.h $(INC)exceptions.h \
- $(INC)peidainit.h matrix.h peida.h utils.h \
- $(INC)machine.h \
- $(INC)perrors.h fmath.h \
- $(INC)ppersist.h \
- $(INC)pclassids.h cvector.h generaldata.h \
- poly.h nbconst.h tabmath.h simps2d.h
-$(OBJ)generaldata.o: generaldata.cc $(INC)defs.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h nbtri.h generalfit.h \
- matrix.h peida.h utils.h fmath.h \
- $(INC)ppersist.h \
- $(INC)pclassids.h cvector.h generaldata.h \
- poly.h
-$(OBJ)generalfit.o: generalfit.cc $(INC)defs.h \
- generalfit.h $(INC)exceptions.h \
- $(INC)peidainit.h matrix.h peida.h utils.h \
- $(INC)machine.h \
- $(INC)perrors.h fmath.h \
- $(INC)ppersist.h \
- $(INC)pclassids.h cvector.h generaldata.h \
- poly.h nbconst.h tabmath.h
-$(OBJ)hisprof.o: hisprof.cc $(INC)defs.h hisprof.h \
- peida.h utils.h $(INC)machine.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h fmath.h cvector.h matrix.h \
- $(INC)ppersist.h \
- $(INC)pclassids.h histos.h
-$(OBJ)histos.o: histos.cc $(INC)defs.h histos.h \
- peida.h utils.h $(INC)machine.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h fmath.h cvector.h matrix.h \
- $(INC)ppersist.h \
- $(INC)pclassids.h poly.h strutil.h \
- generalfit.h generaldata.h
-$(OBJ)histos2.o: histos2.cc $(INC)defs.h histos2.h \
- peida.h utils.h $(INC)machine.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h fmath.h histos.h cvector.h \
+ $(INC)pexceptions.h fmath.h nbmath.h \
+ histos.h $(INC)objfio.h \
+ $(INC)anydataobj.h \
+ $(INC)ppersist.h \
+ $(INC)md5.h cvector.h matrix.h datatypes.h \
+ imageop.h cimage.h rzimage.h rzvect.h dvlist.h cspline.h dynccd.h \
+ nbtri.h
+$(OBJ)integ.o: integ.cc integ.h $(INC)machdefs.h \
+ $(INC)pclassids.h \
+ $(INC)pexceptions.h generalfit.h matrix.h \
+ peida.h utils.h $(INC)perrors.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)md5.h cvector.h generaldata.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h ntupintf.h poly.h
+$(OBJ)linfit.o: linfit.cc $(INC)machdefs.h \
+ $(INC)pclassids.h peida.h utils.h \
+ $(INC)perrors.h \
+ $(INC)pexceptions.h fmath.h linfit.h \
  matrix.h $(INC)ppersist.h \
- $(INC)pclassids.h generalfit.h generaldata.h \
- poly.h
-$(OBJ)imageop.o: imageop.cc $(INC)defs.h simplesort.h \
- peida.h utils.h $(INC)machine.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h fmath.h nbmath.h histos.h \
- cvector.h matrix.h $(INC)ppersist.h \
- $(INC)pclassids.h datatypes.h imageop.h \
- cimage.h rzimage.h rzvect.h dvlist.h cspline.h nbtri.h
-$(OBJ)integ.o: integ.cc $(INC)defs.h integ.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h generalfit.h matrix.h \
- peida.h utils.h $(INC)machine.h \
- $(INC)perrors.h fmath.h \
- $(INC)ppersist.h \
- $(INC)pclassids.h cvector.h generaldata.h \
- poly.h
-$(OBJ)linfit.o: linfit.cc $(INC)defs.h peida.h \
- utils.h $(INC)machine.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h fmath.h linfit.h matrix.h \
- $(INC)ppersist.h \
- $(INC)pclassids.h cvector.h
-$(OBJ)matrix.o: matrix.cc $(INC)defs.h peida.h \
- utils.h $(INC)machine.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h fmath.h matrix.h \
- $(INC)ppersist.h \
- $(INC)pclassids.h cvector.h generalfit.h \
- generaldata.h poly.h
+ $(INC)md5.h cvector.h
+$(OBJ)matrix.o: matrix.cc $(INC)machdefs.h \
+ $(INC)pclassids.h peida.h utils.h \
+ $(INC)perrors.h \
+ $(INC)pexceptions.h fmath.h matrix.h \
+ $(INC)ppersist.h \
+ $(INC)md5.h cvector.h generalfit.h \
+ generaldata.h $(INC)objfio.h \
+ $(INC)anydataobj.h ntupintf.h poly.h \
+ tmatrix.h $(INC)ndatablock.h
 $(OBJ)median.o: median.cc
-$(OBJ)ntuple.o: ntuple.cc $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)defs.h \
- $(INC)peidainit.h ntuple.h \
- $(INC)ppersist.h \
- $(INC)machine.h \
- $(INC)pclassids.h dvlist.h
+$(OBJ)ntupintf.o: ntupintf.cc ntupintf.h \
+ $(INC)machdefs.h \
+ $(INC)pclassids.h
+$(OBJ)ntuple.o: ntuple.cc strutil.h \
+ $(INC)perrors.h \
+ $(INC)pexceptions.h \
+ $(INC)machdefs.h \
+ $(INC)pclassids.h ntuple.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h \
+ $(INC)ppersist.h \
+ $(INC)md5.h ntupintf.h dvlist.h
 $(OBJ)outilsinit.o: outilsinit.cc outilsinit.h \
  $(INC)peidainit.h \
- $(INC)defs.h matrix.h peida.h utils.h \
- $(INC)machine.h \
- $(INC)perrors.h \
- $(INC)exceptions.h fmath.h \
- $(INC)ppersist.h \
- $(INC)pclassids.h cvector.h poly.h dvlist.h \
- histos.h histos2.h hisprof.h ntuple.h generaldata.h cimage.h \
+ $(INC)machdefs.h \
+ $(INC)pclassids.h matrix.h peida.h utils.h \
+ $(INC)perrors.h \
+ $(INC)pexceptions.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)md5.h cvector.h poly.h dvlist.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h histos.h histos2.h \
+ hisprof.h ntuple.h ntupintf.h generaldata.h tmatrix.h \
+ $(INC)ndatablock.h tvector.h cimage.h \
  rzimage.h rzvect.h datatypes.h tabmath.h nbconst.h dates.h datime.h
-$(OBJ)perandom.o: perandom.cc $(INC)defs.h perandom.h \
- $(INC)machine.h histos.h peida.h utils.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h fmath.h cvector.h matrix.h \
- $(INC)ppersist.h \
- $(INC)pclassids.h nbrandom.h pemath.h
-$(OBJ)poly.o: poly.cc $(INC)defs.h poly.h peida.h \
- utils.h $(INC)machine.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h fmath.h cvector.h matrix.h \
- $(INC)ppersist.h \
- $(INC)pclassids.h linfit.h
+$(OBJ)perandom.o: perandom.cc $(INC)machdefs.h \
+ $(INC)pclassids.h \
+ $(INC)pexceptions.h perandom.h histos.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h \
+ $(INC)ppersist.h \
+ $(INC)md5.h peida.h utils.h \
+ $(INC)perrors.h fmath.h cvector.h matrix.h \
+ nbrandom.h pemath.h
+$(OBJ)poly.o: poly.cc $(INC)machdefs.h \
+ $(INC)pclassids.h poly.h peida.h utils.h \
+ $(INC)perrors.h \
+ $(INC)pexceptions.h fmath.h cvector.h \
+ matrix.h $(INC)ppersist.h \
+ $(INC)md5.h linfit.h
 $(OBJ)pversion.o: pversion.cc pversion.h \
  $(INC)peidainit.h \
- $(INC)defs.h
-$(OBJ)rk4cdifeq.o: rk4cdifeq.cc $(INC)defs.h \
- rk4cdifeq.h difeq.h $(INC)exceptions.h \
- $(INC)peidainit.h cvector.h matrix.h peida.h \
- utils.h $(INC)machine.h \
- $(INC)perrors.h fmath.h \
- $(INC)ppersist.h \
- $(INC)pclassids.h \
- $(INC)ctimer.h \
- $(INC)peida.h
-$(OBJ)rzimage.o: rzimage.cc $(INC)defs.h rzimage.h \
- rzvect.h $(INC)machine.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h \
+ $(INC)machdefs.h \
+ $(INC)pclassids.h
+$(OBJ)rk4cdifeq.o: rk4cdifeq.cc $(INC)machdefs.h \
+ $(INC)pclassids.h rk4cdifeq.h difeq.h \
+ $(INC)pexceptions.h cvector.h matrix.h \
+ peida.h utils.h $(INC)perrors.h fmath.h \
+ $(INC)ppersist.h \
+ $(INC)md5.h \
+ $(INC)ctimer.h
+$(OBJ)rzimage.o: rzimage.cc $(INC)machdefs.h \
+ $(INC)pclassids.h rzimage.h rzvect.h \
+ $(INC)pexceptions.h \
  $(INC)perrors.h datatypes.h \
  $(INC)ppersist.h \
- $(INC)pclassids.h dvlist.h generalfit.h \
- matrix.h peida.h utils.h fmath.h cvector.h generaldata.h poly.h
-$(OBJ)simplesort.o: simplesort.cc $(INC)defs.h \
- simplesort.h peida.h utils.h $(INC)machine.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h fmath.h
-$(OBJ)tabmath.o: tabmath.cc $(INC)defs.h tabmath.h \
- peida.h utils.h $(INC)machine.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h fmath.h nbconst.h
-$(OBJ)utils.o: utils.cc $(INC)defs.h utils.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h
-$(OBJ)datime.o: datime.c $(INC)defs.h strutil.h \
- nbconst.h datime.h
-$(OBJ)matxop.o: matxop.c matxop.h nbmath.h
-$(OBJ)nbmath.o: nbmath.c nbmath.h matxop.h nbinteg.h nbtri.h
-$(OBJ)nbrandom.o: nbrandom.c $(INC)defs.h \
- $(INC)machine.h nbmath.h nbrandom.h
-$(OBJ)nbtri.o: nbtri.c nbtri.h
+ $(INC)md5.h dvlist.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h generalfit.h matrix.h \
+ peida.h utils.h fmath.h cvector.h generaldata.h ntupintf.h poly.h
+$(OBJ)simplesort.o: simplesort.cc $(INC)machdefs.h \
+ $(INC)pclassids.h simplesort.h peida.h \
+ utils.h $(INC)perrors.h \
+ $(INC)pexceptions.h fmath.h
+$(OBJ)tabmath.o: tabmath.cc $(INC)machdefs.h \
+ $(INC)pclassids.h tabmath.h peida.h utils.h \
+ $(INC)perrors.h \
+ $(INC)pexceptions.h fmath.h nbconst.h
+$(OBJ)tmatrix.o: tmatrix.cc $(INC)machdefs.h \
+ $(INC)pclassids.h \
+ $(INC)pexceptions.h tmatrix.h \
+ $(INC)ppersist.h \
+ $(INC)md5.h \
+ $(INC)anydataobj.h \
+ $(INC)ndatablock.h \
+ $(INC)objfio.h matrix.h peida.h utils.h \
+ $(INC)perrors.h fmath.h generalfit.h \
+ cvector.h generaldata.h ntupintf.h poly.h tvector.h
+$(OBJ)tvector.o: tvector.cc $(INC)machdefs.h \
+ $(INC)pclassids.h \
+ $(INC)pexceptions.h tvector.h tmatrix.h \
+ $(INC)ppersist.h \
+ $(INC)md5.h \
+ $(INC)anydataobj.h \
+ $(INC)ndatablock.h \
+ $(INC)objfio.h generalfit.h matrix.h \
+ peida.h utils.h $(INC)perrors.h fmath.h \
+ cvector.h generaldata.h ntupintf.h poly.h
+$(OBJ)utils.o: utils.cc $(INC)machdefs.h \
+ $(INC)pclassids.h utils.h \
+ $(INC)pexceptions.h
+$(OBJ)datime.o: datime.c $(INC)machdefs.h \
+ strutil.h nbconst.h datime.h
+$(OBJ)fftpackc.o: fftpackc.c fftpackc.h \
+ $(INC)machdefs.h
+$(OBJ)matxop.o: matxop.c matxop.h nbmath.h \
+ $(INC)machdefs.h
+$(OBJ)nbmath.o: nbmath.c nbmath.h $(INC)machdefs.h \
+ matxop.h nbinteg.h nbtri.h
+$(OBJ)nbrandom.o: nbrandom.c $(INC)machdefs.h \
+ nbmath.h nbrandom.h
+$(OBJ)nbtri.o: nbtri.c nbtri.h $(INC)machdefs.h
 $(OBJ)strutil.o: strutil.c strutil.h